diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/doc/main.h ns-3.38/doc/main.h
--- ns-3.37/doc/main.h	2022-11-01 17:37:24.375394800 -0700
+++ ns-3.38/doc/main.h	2023-03-16 20:54:23.500868000 -0700
@@ -2,6 +2,7 @@
  * \file
  * Main page of the Doxygen-generated documentation.
  */
+
 /**
  * \mainpage ns-3 Documentation
  *
@@ -70,6 +71,7 @@
  *     - wimax
  *
  */
+
 /**
  * \namespace ns3
  * \brief Every class exported by the ns3 library is enclosed in the
@@ -107,3 +109,12 @@
 #define NS3_LOG_ENABLE
 
 /**@}*/
+
+/**
+ * \page EnvironVar All Environment Variables
+ *
+ * All environment variables used by ns-3 are documented by module.
+ *
+ * \section environcore Core Environment Variables
+ * See \ref core-environ
+ */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/doc/manual/Makefile ns-3.38/doc/manual/Makefile
--- ns-3.37/doc/manual/Makefile	2022-11-01 17:37:24.375394800 -0700
+++ ns-3.38/doc/manual/Makefile	2023-03-16 20:54:23.500868000 -0700
@@ -26,7 +26,7 @@
 	source/hash-functions.rst \
 	source/helpers.rst \
 	source/how-to-write-tests.rst \
-	source/logging.rst \
+	source/logging-asserts.rst \
 	source/new-models.rst \
 	source/new-modules.rst \
 	source/object-model.rst \
@@ -45,7 +45,6 @@
 	source/tracing.rst \
 	source/troubleshoot.rst \
 	source/utilities.rst \
-	source/windows.rst \
 	source/working-with-cmake.rst \
 	source/working-with-git.rst \
 	source/working-with-gitlab-ci-local.rst \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/doc/models/Makefile ns-3.38/doc/models/Makefile
--- ns-3.37/doc/models/Makefile	2022-11-01 17:37:24.411394800 -0700
+++ ns-3.38/doc/models/Makefile	2023-03-16 20:54:23.536868300 -0700
@@ -343,6 +343,9 @@
 	$(SRC)/spectrum/doc/spectrum-tv-rand-geo-points.eps \
 	$(SRC)/spectrum/doc/spectrum-tv-8vsb.png \
 	$(SRC)/spectrum/doc/spectrum-tv-cofdm.png \
+	$(SRC)/spectrum/doc/two-ray-spectrum-loss-model-3gpp-radiation-pattern.png \
+	$(SRC)/spectrum/doc/two-ray-spectrum-loss-model-iso-radiation-pattern.png \
+	$(SRC)/spectrum/doc/three-gpp-gain-reference-gain-vs-fc.png \
 	$(SRC)/traffic-control/doc/classful-queue-disc.dia \
 	$(SRC)/traffic-control/doc/multi-queue-aware-queue-disc.dia \
 	$(SRC)/traffic-control/doc/figures/collision_prob.jpeg \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/doc/modules ns-3.38/doc/modules
--- ns-3.37/doc/modules	2022-11-01 17:37:24.411394800 -0700
+++ ns-3.38/doc/modules	2023-03-16 20:54:23.536868300 -0700
@@ -1,17 +1,14 @@
 /**
  * @file
  * @ingroup utils
- * @brief Definition of support modules Constants, Utils, Example programs and
+ * @brief Definition of support modules Utils, Example programs and
  * Test suites.
  */
 /**
  * @anchor modules_anchor
  *
- * @defgroup constants Constants
- * @brief Constants you can change
- *
  * @defgroup utils Utils
- * @brief The utils directory is for various programs and scripts related 
+ * @brief The utils directory is for various programs and scripts related
  * to code coverage, test suites, style checking, and benchmarking.
  *
  * @defgroup examples Example programs
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/energy/energy-model-example.cc ns-3.38/examples/energy/energy-model-example.cc
--- ns-3.37/examples/energy/energy-model-example.cc	2022-11-01 17:37:24.439395000 -0700
+++ ns-3.38/examples/energy/energy-model-example.cc	2023-03-16 20:54:23.568868400 -0700
@@ -39,7 +39,7 @@
  * Print a received packet
  *
  * \param from sender address
- * \return a sting with the details of the packet: dst {IP, port}, time.
+ * \return a string with the details of the packet: dst {IP, port}, time.
  */
 static inline std::string
 PrintReceivedPacket(Address& from)
@@ -186,7 +186,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents();
+        WifiHelper::EnableLogComponents();
     }
     wifi.SetStandard(WIFI_STANDARD_80211b);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/energy/energy-model-with-harvesting-example.cc ns-3.38/examples/energy/energy-model-with-harvesting-example.cc
--- ns-3.37/examples/energy/energy-model-with-harvesting-example.cc	2022-11-01 17:37:24.439395000 -0700
+++ ns-3.38/examples/energy/energy-model-with-harvesting-example.cc	2023-03-16 20:54:23.568868400 -0700
@@ -68,7 +68,7 @@
  * Print a received packet
  *
  * \param from sender address
- * \return a sting with the details of the packet: dst {IP, port}, time.
+ * \return a string with the details of the packet: dst {IP, port}, time.
  */
 static inline std::string
 PrintReceivedPacket(Address& from)
@@ -234,7 +234,7 @@
     WifiHelper wifi;
     if (verbose)
     {
-        wifi.EnableLogComponents();
+        WifiHelper::EnableLogComponents();
     }
     wifi.SetStandard(WIFI_STANDARD_80211b);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/error-model/simple-error-model.cc ns-3.38/examples/error-model/simple-error-model.cc
--- ns-3.37/examples/error-model/simple-error-model.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/error-model/simple-error-model.cc	2023-03-16 20:54:23.568868400 -0700
@@ -158,7 +158,7 @@
 
     // Now, let's use the ListErrorModel and explicitly force a loss
     // of the packets with pkt-uids = 11 and 17 on node 2, device 0
-    std::list<uint32_t> sampleList;
+    std::list<uint64_t> sampleList;
     sampleList.push_back(11);
     sampleList.push_back(17);
     // This time, we'll explicitly create the error model we want
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/CMakeLists.txt ns-3.38/examples/ipv6/CMakeLists.txt
--- ns-3.37/examples/ipv6/CMakeLists.txt	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/CMakeLists.txt	2023-03-16 20:54:23.568868400 -0700
@@ -2,18 +2,18 @@
   NAME fragmentation-ipv6
   SOURCE_FILES fragmentation-ipv6.cc
   LIBRARIES_TO_LINK
+    ${libapplications}
     ${libcsma}
     ${libinternet}
-    ${libinternet-apps}
 )
 
 build_example(
   NAME fragmentation-ipv6-two-MTU
   SOURCE_FILES fragmentation-ipv6-two-MTU.cc
   LIBRARIES_TO_LINK
+    ${libapplications}
     ${libcsma}
     ${libinternet}
-    ${libinternet-apps}
 )
 
 build_example(
@@ -35,8 +35,8 @@
 )
 
 build_example(
-  NAME ping6
-  SOURCE_FILES ping6.cc
+  NAME ping6-example
+  SOURCE_FILES ping6-example.cc
   LIBRARIES_TO_LINK
     ${libcsma}
     ${libinternet}
@@ -44,8 +44,8 @@
 )
 
 build_example(
-  NAME radvd
-  SOURCE_FILES radvd.cc
+  NAME radvd-one-prefix
+  SOURCE_FILES radvd-one-prefix.cc
   LIBRARIES_TO_LINK
     ${libcsma}
     ${libinternet}
@@ -74,17 +74,17 @@
   LIBRARIES_TO_LINK
     ${liblr-wpan}
     ${libinternet}
+    ${libinternet-apps}
     ${libsixlowpan}
     ${libmobility}
-    ${libinternet-apps}
 )
 
 build_example(
   NAME fragmentation-ipv6-PMTU
   SOURCE_FILES fragmentation-ipv6-PMTU.cc
   LIBRARIES_TO_LINK
+    ${libapplications}
     ${libcsma}
     ${libinternet}
-    ${libinternet-apps}
     ${libpoint-to-point}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/fragmentation-ipv6.cc ns-3.38/examples/ipv6/fragmentation-ipv6.cc
--- ns-3.37/examples/ipv6/fragmentation-ipv6.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/fragmentation-ipv6.cc	2023-03-16 20:54:23.568868400 -0700
@@ -27,6 +27,7 @@
 // //
 // // - Tracing of queues and packet receptions to file "fragmentation-ipv6.tr"
 
+#include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/internet-apps-module.h"
@@ -55,8 +56,10 @@
         LogComponentEnable("Icmpv6L4Protocol", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6StaticRouting", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("UdpEchoClientApplication", LOG_LEVEL_ALL);
+        LogComponentEnable("UdpEchoServerApplication", LOG_LEVEL_ALL);
     }
+    LogComponentEnable("UdpEchoClientApplication", LOG_LEVEL_INFO);
 
     NS_LOG_INFO("Create nodes.");
     Ptr<Node> n0 = CreateObject<Node>();
@@ -89,25 +92,24 @@
     i2.SetForwarding(0, true);
     i2.SetDefaultRouteInAllNodes(0);
 
-    Ipv6StaticRoutingHelper routingHelper;
     Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
-    routingHelper.PrintRoutingTableAt(Seconds(0), n0, routingStream);
+    Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(0), n0, routingStream);
 
-    /* Create a Ping6 application to send ICMPv6 echo request from n0 to n1 via r */
+    /* Create a UdpEchoClient and UdpEchoServer application to send packets from n0 to n1 via r */
     uint32_t packetSize = 4096;
     uint32_t maxPacketCount = 5;
-    Time interPacketInterval = Seconds(1.0);
-    Ping6Helper ping6;
 
-    ping6.SetLocal(i1.GetAddress(0, 1));
-    ping6.SetRemote(i2.GetAddress(1, 1));
-
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(net1.Get(0));
-    apps.Start(Seconds(2.0));
-    apps.Stop(Seconds(20.0));
+    UdpEchoClientHelper echoClient(i2.GetAddress(1, 1), 42);
+    echoClient.SetAttribute("PacketSize", UintegerValue(packetSize));
+    echoClient.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
+    ApplicationContainer clientApps = echoClient.Install(net1.Get(0));
+    clientApps.Start(Seconds(2.0));
+    clientApps.Stop(Seconds(20.0));
+
+    UdpEchoServerHelper echoServer(42);
+    ApplicationContainer serverApps = echoServer.Install(net2.Get(1));
+    serverApps.Start(Seconds(0.0));
+    serverApps.Stop(Seconds(30.0));
 
     AsciiTraceHelper ascii;
     csma.EnableAsciiAll(ascii.CreateFileStream("fragmentation-ipv6.tr"));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/fragmentation-ipv6-PMTU.cc ns-3.38/examples/ipv6/fragmentation-ipv6-PMTU.cc
--- ns-3.37/examples/ipv6/fragmentation-ipv6-PMTU.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/fragmentation-ipv6-PMTU.cc	2023-03-16 20:54:23.568868400 -0700
@@ -30,6 +30,7 @@
 // //
 // // - Tracing of queues and packet receptions to file "fragmentation-ipv6-PMTU.tr"
 
+#include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/internet-apps-module.h"
@@ -60,8 +61,10 @@
         LogComponentEnable("Icmpv6L4Protocol", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6StaticRouting", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("UdpEchoClientApplication", LOG_LEVEL_ALL);
+        LogComponentEnable("UdpEchoServerApplication", LOG_LEVEL_ALL);
     }
+    LogComponentEnable("UdpEchoClientApplication", LOG_LEVEL_INFO);
 
     NS_LOG_INFO("Create nodes.");
     Ptr<Node> n0 = CreateObject<Node>();
@@ -117,35 +120,33 @@
     i3.SetForwarding(0, true);
     i3.SetDefaultRouteInAllNodes(0);
 
-    Ipv6StaticRoutingHelper routingHelper;
     Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
-    routingHelper.PrintRoutingTableAt(Seconds(0), r1, routingStream);
+    Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(0), r1, routingStream);
 
-    /* Create a Ping6 application to send ICMPv6 echo request from r to n2 */
-    uint32_t packetSize = 1600; // Packet should fragment as intermediate link MTU is 1500
-    uint32_t maxPacketCount = 5;
-    Time interPacketInterval = Seconds(1.0);
-    Ping6Helper ping6;
+    // Create an UDP Echo server on n2
+    UdpEchoServerHelper echoServer(42);
+    ApplicationContainer serverApps = echoServer.Install(n2);
+    serverApps.Start(Seconds(0.0));
+    serverApps.Stop(Seconds(30.0));
 
-    ping6.SetLocal(i2.GetAddress(1, 1));
-    ping6.SetRemote(i3.GetAddress(1, 1));
+    uint32_t maxPacketCount = 5;
 
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(n1);
-    apps.Start(Seconds(2.0));
-    apps.Stop(Seconds(10.0));
-
-    /* Create a Ping6 application to send ICMPv6 echo request from n0 to n2 */
-    packetSize = 4000;
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-
-    ping6.SetLocal(i1.GetAddress(0, 1));
-    ping6.SetRemote(i3.GetAddress(1, 1));
-    apps = ping6.Install(n0);
-    apps.Start(Seconds(11.0));
-    apps.Stop(Seconds(20.0));
+    // Create an UDP Echo client on n1 to send UDP packets to n2 via r1
+    uint32_t packetSizeN1 = 1600; // Packet should fragment as intermediate link MTU is 1500
+    UdpEchoClientHelper echoClient(i3.GetAddress(1, 1), 42);
+    echoClient.SetAttribute("PacketSize", UintegerValue(packetSizeN1));
+    echoClient.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
+    ApplicationContainer clientAppsN1 = echoClient.Install(n1);
+    clientAppsN1.Start(Seconds(2.0));
+    clientAppsN1.Stop(Seconds(10.0));
+
+    // Create an UDP Echo client on n0 to send UDP packets to n2 via r0 and r1
+    uint32_t packetSizeN2 = 4000; // Packet should fragment as intermediate link MTU is 1500
+    echoClient.SetAttribute("PacketSize", UintegerValue(packetSizeN2));
+    echoClient.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
+    ApplicationContainer clientAppsN2 = echoClient.Install(n1);
+    clientAppsN2.Start(Seconds(11.0));
+    clientAppsN2.Stop(Seconds(20.0));
 
     AsciiTraceHelper ascii;
     csma.EnableAsciiAll(ascii.CreateFileStream("fragmentation-ipv6-PMTU.tr"));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/fragmentation-ipv6-two-MTU.cc ns-3.38/examples/ipv6/fragmentation-ipv6-two-MTU.cc
--- ns-3.37/examples/ipv6/fragmentation-ipv6-two-MTU.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/fragmentation-ipv6-two-MTU.cc	2023-03-16 20:54:23.568868400 -0700
@@ -29,6 +29,7 @@
 // //
 // // - Tracing of queues and packet receptions to file "fragmentation-ipv6-two-mtu.tr"
 
+#include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/internet-apps-module.h"
@@ -57,8 +58,10 @@
         LogComponentEnable("Icmpv6L4Protocol", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6StaticRouting", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("UdpEchoClientApplication", LOG_LEVEL_ALL);
+        LogComponentEnable("UdpEchoServerApplication", LOG_LEVEL_ALL);
     }
+    LogComponentEnable("UdpEchoClientApplication", LOG_LEVEL_INFO);
 
     NS_LOG_INFO("Create nodes.");
     Ptr<Node> n0 = CreateObject<Node>();
@@ -92,25 +95,24 @@
     i2.SetForwarding(0, true);
     i2.SetDefaultRouteInAllNodes(0);
 
-    Ipv6StaticRoutingHelper routingHelper;
     Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
-    routingHelper.PrintRoutingTableAt(Seconds(0), n0, routingStream);
+    Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(0), n0, routingStream);
 
-    /* Create a Ping6 application to send ICMPv6 echo request from n0 to n1 via r */
+    /* Create a UdpEchoClient and UdpEchoServer application to send packets from n0 to n1 via r */
     uint32_t packetSize = 4096;
     uint32_t maxPacketCount = 5;
-    Time interPacketInterval = Seconds(1.0);
-    Ping6Helper ping6;
 
-    ping6.SetLocal(i1.GetAddress(0, 1));
-    ping6.SetRemote(i2.GetAddress(1, 1));
-
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(net1.Get(0));
-    apps.Start(Seconds(2.0));
-    apps.Stop(Seconds(20.0));
+    UdpEchoClientHelper echoClient(i2.GetAddress(1, 1), 42);
+    echoClient.SetAttribute("PacketSize", UintegerValue(packetSize));
+    echoClient.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
+    ApplicationContainer clientApps = echoClient.Install(net1.Get(0));
+    clientApps.Start(Seconds(2.0));
+    clientApps.Stop(Seconds(20.0));
+
+    UdpEchoServerHelper echoServer(42);
+    ApplicationContainer serverApps = echoServer.Install(net2.Get(1));
+    serverApps.Start(Seconds(0.0));
+    serverApps.Stop(Seconds(30.0));
 
     AsciiTraceHelper ascii;
     csma.EnableAsciiAll(ascii.CreateFileStream("fragmentation-ipv6-two-mtu.tr"));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/icmpv6-redirect.cc ns-3.38/examples/ipv6/icmpv6-redirect.cc
--- ns-3.37/examples/ipv6/icmpv6-redirect.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/icmpv6-redirect.cc	2023-03-16 20:54:23.568868400 -0700
@@ -114,21 +114,17 @@
                             iic1.GetInterfaceIndex(1));
 
     Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
-    routingHelper.PrintRoutingTableAt(Seconds(0.0), r1, routingStream);
-    routingHelper.PrintRoutingTableAt(Seconds(3.0), sta1, routingStream);
+    Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(0.0), r1, routingStream);
+    Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(3.0), sta1, routingStream);
 
     NS_LOG_INFO("Create Applications.");
     uint32_t packetSize = 1024;
     uint32_t maxPacketCount = 5;
-    Time interPacketInterval = Seconds(1.);
-    Ping6Helper ping6;
+    PingHelper ping(iic2.GetAddress(1, 1));
 
-    ping6.SetLocal(iic1.GetAddress(0, 1));
-    ping6.SetRemote(iic2.GetAddress(1, 1));
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(sta1);
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(sta1);
     apps.Start(Seconds(2.0));
     apps.Stop(Seconds(10.0));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/loose-routing-ipv6.cc ns-3.38/examples/ipv6/loose-routing-ipv6.cc
--- ns-3.37/examples/ipv6/loose-routing-ipv6.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/loose-routing-ipv6.cc	2023-03-16 20:54:23.568868400 -0700
@@ -60,7 +60,7 @@
 
     if (verbose)
     {
-        LogComponentEnable("Ipv6ExtensionLooseRouting", LOG_LEVEL_ALL);
+        // LogComponentEnable("Ipv6ExtensionLooseRouting", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6Extension", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6L3Protocol", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6StaticRouting", LOG_LEVEL_ALL);
@@ -69,6 +69,8 @@
         LogComponentEnable("NdiscCache", LOG_LEVEL_ALL);
     }
 
+    // LogComponentEnable("Ping", LOG_LEVEL_INFO);
+
     NS_LOG_INFO("Create nodes.");
     Ptr<Node> h0 = CreateObject<Node>();
     Ptr<Node> h1 = CreateObject<Node>();
@@ -164,16 +166,16 @@
     routersAddress.push_back(i6.GetAddress(1, 1));
     routersAddress.push_back(i2.GetAddress(0, 1));
 
-    Ping6Helper client;
-    /* remote address is first routers in RH0 => source routing */
-    client.SetRemote(i1.GetAddress(1, 1));
-    client.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
+    // remote address is first routers in RH0 => source routing
+    PingHelper client(i1.GetAddress(1, 1));
+    client.SetAttribute("Count", UintegerValue(maxPacketCount));
     client.SetAttribute("Interval", TimeValue(interPacketInterval));
-    client.SetAttribute("PacketSize", UintegerValue(packetSize));
-    client.SetRoutersAddress(routersAddress);
+    client.SetAttribute("Size", UintegerValue(packetSize));
     ApplicationContainer apps = client.Install(h0);
+    DynamicCast<Ping>(apps.Get(0))->SetRouters(routersAddress);
+
     apps.Start(Seconds(1.0));
-    apps.Stop(Seconds(10.0));
+    apps.Stop(Seconds(20.0));
 
     AsciiTraceHelper ascii;
     csma.EnableAsciiAll(ascii.CreateFileStream("loose-routing-ipv6.tr"));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/ping6-example.cc ns-3.38/examples/ipv6/ping6-example.cc
--- ns-3.37/examples/ipv6/ping6-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/examples/ipv6/ping6-example.cc	2023-03-16 20:54:23.568868400 -0700
@@ -0,0 +1,112 @@
+/*
+ * Copyright (c) 2008-2009 Strasbourg University
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sebastien Vincent <vincent@clarinet.u-strasbg.fr>
+ */
+
+// Network topology
+//
+//       n0    n1
+//       |     |
+//       =================
+//              LAN
+//
+// - ICMPv6 echo request flows from n0 to n1 and back with ICMPv6 echo reply
+// - DropTail queues
+// - Tracing of queues and packet receptions to file "ping6.tr"
+
+#include "ns3/core-module.h"
+#include "ns3/csma-module.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/internet-module.h"
+
+#include <fstream>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("Ping6Example");
+
+int
+main(int argc, char** argv)
+{
+    bool verbose = false;
+    bool allNodes = false;
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("verbose", "turn on log components", verbose);
+    cmd.AddValue("allNodes", "Ping all the nodes (true) or just one neighbor (false)", allNodes);
+    cmd.Parse(argc, argv);
+
+    if (verbose)
+    {
+        LogComponentEnable("Ping6Example", LOG_LEVEL_INFO);
+        LogComponentEnable("Ipv6EndPointDemux", LOG_LEVEL_ALL);
+        LogComponentEnable("Ipv6L3Protocol", LOG_LEVEL_ALL);
+        LogComponentEnable("Ipv6StaticRouting", LOG_LEVEL_ALL);
+        LogComponentEnable("Ipv6ListRouting", LOG_LEVEL_ALL);
+        LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
+        LogComponentEnable("Icmpv6L4Protocol", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
+        LogComponentEnable("NdiscCache", LOG_LEVEL_ALL);
+    }
+
+    NS_LOG_INFO("Create nodes.");
+    NodeContainer n;
+    n.Create(4);
+
+    /* Install IPv4/IPv6 stack */
+    InternetStackHelper internetv6;
+    internetv6.SetIpv4StackInstall(false);
+    internetv6.Install(n);
+
+    NS_LOG_INFO("Create channels.");
+    CsmaHelper csma;
+    csma.SetChannelAttribute("DataRate", DataRateValue(5000000));
+    csma.SetChannelAttribute("Delay", TimeValue(MilliSeconds(2)));
+    NetDeviceContainer d = csma.Install(n);
+
+    Ipv6AddressHelper ipv6;
+    NS_LOG_INFO("Assign IPv6 Addresses.");
+    Ipv6InterfaceContainer i = ipv6.Assign(d);
+
+    NS_LOG_INFO("Create Applications.");
+
+    // Create a Ping application to send ICMPv6 echo request from node zero
+    uint32_t packetSize = 1024;
+    uint32_t maxPacketCount = 5;
+
+    Ipv6Address destination = allNodes ? Ipv6Address::GetAllNodesMulticast() : i.GetAddress(1, 0);
+    PingHelper ping(destination);
+
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ping.SetAttribute("InterfaceAddress", AddressValue(i.GetAddress(0, 0)));
+
+    ApplicationContainer apps = ping.Install(n.Get(0));
+    apps.Start(Seconds(2.0));
+    apps.Stop(Seconds(10.0));
+
+    AsciiTraceHelper ascii;
+    csma.EnableAsciiAll(ascii.CreateFileStream("ping6.tr"));
+    csma.EnablePcapAll(std::string("ping6"), true);
+
+    NS_LOG_INFO("Run Simulation.");
+    Simulator::Run();
+    Simulator::Destroy();
+    NS_LOG_INFO("Done.");
+
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/radvd-one-prefix.cc ns-3.38/examples/ipv6/radvd-one-prefix.cc
--- ns-3.37/examples/ipv6/radvd-one-prefix.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/examples/ipv6/radvd-one-prefix.cc	2023-03-16 20:54:23.568868400 -0700
@@ -0,0 +1,153 @@
+/*
+ * Copyright (c) 2009 Strasbourg University
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: David Gross <gdavid.devel@gmail.com>
+ *         Sebastien Vincent <vincent@clarinet.u-strasbg.fr>
+ */
+
+// Network topology
+// //
+// //             n0   R    n1
+// //             |    _    |
+// //             ====|_|====
+// //                router
+// // - R sends RA to n0's subnet (2001:1::/64);
+// // - R sends RA to n1's subnet (2001:2::/64);
+// // - n0 ping n1.
+// //
+// // - Tracing of queues and packet receptions to file "radvd.tr"
+
+#include "ns3/core-module.h"
+#include "ns3/csma-module.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/radvd-interface.h"
+#include "ns3/radvd-prefix.h"
+#include "ns3/radvd.h"
+
+#include <fstream>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("RadvdExample");
+
+int
+main(int argc, char** argv)
+{
+    bool verbose = false;
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("verbose", "turn on log components", verbose);
+    cmd.Parse(argc, argv);
+
+    if (verbose)
+    {
+        LogComponentEnable("Ipv6L3Protocol", LOG_LEVEL_ALL);
+        LogComponentEnable("Ipv6RawSocketImpl", LOG_LEVEL_ALL);
+        LogComponentEnable("Icmpv6L4Protocol", LOG_LEVEL_ALL);
+        LogComponentEnable("Ipv6StaticRouting", LOG_LEVEL_ALL);
+        LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
+        LogComponentEnable("RadvdApplication", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
+    }
+
+    NS_LOG_INFO("Create nodes.");
+    Ptr<Node> n0 = CreateObject<Node>();
+    Ptr<Node> r = CreateObject<Node>();
+    Ptr<Node> n1 = CreateObject<Node>();
+
+    NodeContainer net1(n0, r);
+    NodeContainer net2(r, n1);
+    NodeContainer all(n0, r, n1);
+
+    NS_LOG_INFO("Create IPv6 Internet Stack");
+    InternetStackHelper internetv6;
+    internetv6.Install(all);
+
+    NS_LOG_INFO("Create channels.");
+    CsmaHelper csma;
+    csma.SetChannelAttribute("DataRate", DataRateValue(5000000));
+    csma.SetChannelAttribute("Delay", TimeValue(MilliSeconds(2)));
+    NetDeviceContainer d1 = csma.Install(net1); /* n0 - R */
+    NetDeviceContainer d2 = csma.Install(net2); /* R - n1 */
+
+    NS_LOG_INFO("Create networks and assign IPv6 Addresses.");
+    Ipv6AddressHelper ipv6;
+
+    /* first subnet */
+    ipv6.SetBase(Ipv6Address("2001:1::"), Ipv6Prefix(64));
+    NetDeviceContainer tmp;
+    tmp.Add(d1.Get(0));                                           /* n0 */
+    Ipv6InterfaceContainer iic1 = ipv6.AssignWithoutAddress(tmp); /* n0 interface */
+
+    NetDeviceContainer tmp2;
+    tmp2.Add(d1.Get(1)); /* R */
+    Ipv6InterfaceContainer iicr1 =
+        ipv6.Assign(tmp2); /* R interface to the first subnet is just statically assigned */
+    iicr1.SetForwarding(0, true);
+    iic1.Add(iicr1);
+
+    /* second subnet R - n1 */
+    ipv6.SetBase(Ipv6Address("2001:2::"), Ipv6Prefix(64));
+    NetDeviceContainer tmp3;
+    tmp3.Add(d2.Get(0));                              /* R */
+    Ipv6InterfaceContainer iicr2 = ipv6.Assign(tmp3); /* R interface */
+    iicr2.SetForwarding(0, true);
+
+    NetDeviceContainer tmp4;
+    tmp4.Add(d2.Get(1)); /* n1 */
+    Ipv6InterfaceContainer iic2 = ipv6.AssignWithoutAddress(tmp4);
+    iic2.Add(iicr2);
+
+    /* radvd configuration */
+    RadvdHelper radvdHelper;
+
+    /* R interface (n0 - R) */
+    /* n0 will receive unsolicited (periodic) RA */
+    radvdHelper.AddAnnouncedPrefix(iic1.GetInterfaceIndex(1), Ipv6Address("2001:1::0"), 64);
+
+    /* R interface (R - n1) */
+    /* n1 will have to use RS, as RA are not sent automatically */
+    radvdHelper.AddAnnouncedPrefix(iic2.GetInterfaceIndex(1), Ipv6Address("2001:2::0"), 64);
+    radvdHelper.GetRadvdInterface(iic2.GetInterfaceIndex(1))->SetSendAdvert(false);
+
+    ApplicationContainer radvdApps = radvdHelper.Install(r);
+    radvdApps.Start(Seconds(1.0));
+    radvdApps.Stop(Seconds(10.0));
+
+    /* Create a Ping application to send ICMPv6 echo request from n0 to n1 via R */
+    uint32_t packetSize = 1024;
+    uint32_t maxPacketCount = 5;
+    PingHelper ping(
+        Ipv6Address("2001:2::200:ff:fe00:4")); /* should be n1 address after autoconfiguration */
+
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(net1.Get(0));
+    apps.Start(Seconds(2.0));
+    apps.Stop(Seconds(7.0));
+
+    AsciiTraceHelper ascii;
+    csma.EnableAsciiAll(ascii.CreateFileStream("radvd.tr"));
+    csma.EnablePcapAll(std::string("radvd"), true);
+
+    NS_LOG_INFO("Run Simulation.");
+    Simulator::Run();
+    Simulator::Destroy();
+    NS_LOG_INFO("Done.");
+
+    return 0;
+}
